// I18N constants

// LANG: "pt_br", ENCODING: UTF-8 | ISO-8859-1
// Author: Agner Olson, agner@agner.net for Portuguese brasilian
// Joo P Matos, jmatos@math.ist.utl.pt for European Portuguese

// FOR TRANSLATORS:
//
//   1. PLEASE PUT YOUR CONTACT INFO IN THE ABOVE LINE
//      (at least a valid email address)
//
//   2. PLEASE TRY TO USE UTF-8 FOR ENCODING;
//      (if this is not possible, please include a comment
//       that states what encoding is necessary.)


HTMLArea.I18N = {

	// the following should be the filename without .js extension
	// it will be used for automatically load plugin language.
	lang: "pt_br",

	tooltips: {
		bold:           "Negrito",
		italic:         "Itlico",
		underline:      "Sublinhado",
		strikethrough:  "Riscado",
		subscript:      "Subscrito",
		superscript:    "Sobrescrito",
		justifyleft:    "Alinhado  esquerda",
		justifycenter:  "Centralizado",
		justifyright:   "Alinhado  direita",
		justifyfull:    "Justificado",
		orderedlist:    "Lista ordenada",
		unorderedlist:  "Lista no ordenada",
		outdent:        "Diminuir a indentao",
		indent:         "Aumentar a indentao",
		forecolor:      "Cor do texto",
		hilitecolor:    "Cor de nfase",
		horizontalrule: "Linha horizontal",
		createlink:     "Inserir uma hiperligao",
		insertimage:    "Inserir/Modificar uma imagem",
		inserttable:    "Inserir uma tabela",
		htmlmode:       "Mostrar cdigo fonte",
		popupeditor:    "Maximizar o editor",
		about:          "Sobre o editor",
		showhelp:       "Ajuda",
		textindicator:  "Estilo corrente",
		undo:           "Anular a ltima ao",
		redo:           "Repetir a ltima ao",
		cut:            "Cortar",
		copy:           "Copiar",
		paste:          "Colar",
		lefttoright:    "Da esquerda para a direita",
		righttoleft:    "Da direita para a esquerda"
	},

	buttons: {
		"ok":           "OK",
		"cancel":       "Cancelar"
	},

	msg: {
		"Path":         "Caminho",
		"TEXT_MODE":    "Est em MODO TEXTO.  Pressione o boto [<>] para voltar ao modo grfico.",

		"IE-sucks-full-screen" :
		// translate here
		"O modo rea de trabalho completo pode causar problemas no IE, " +
		"devido aos seus problemas que no foi possvel de evitar.  " +
		"Os sintomas podem ser erros na rea de trabalho ou falta de algumas" +
		"funes no editor ou falhas catastrficas do sistema operacional.  Se o seu  " +
		"sistema  Windows 9x,  possvel o erro " +
		"'General Protection Fault' acontea e que voc tenha de reiniciar o computador." +
		"\n\nConsidere-se avisado.  Pressione OK se deseja continuar mesmo assim " +
		"testando o modo de tela cheia."
	},

	dialogs: {
		"OK"                                                : "OK",
		"Cancel"                                            : "Cancelar",
		"Alignment:"                                        : "Alinhamento:",
		"Not set"                                           : "No definido",
		"Left"                                              : "Esquerda",
		"Right"                                             : "Direita",
		"Texttop"                                           : "Topo do texto",
		"Absmiddle"                                         : "Meio absoluto",
		"Baseline"                                          : "Linha base",
		"Absbottom"                                         : "Abaixo absoluto",
		"Bottom"                                            : "Fundo",
		"Middle"                                            : "Meio",
		"Top"                                               : "Topo",

		"Layout"                                            : "Formatao",
		"Spacing"                                           : "Espaamento",
		"Horizontal:"                                       : "Horizontal:",
		"Horizontal padding"                                : "Enchimento horizontal",
		"Vertical:"                                         : "Vertical:",
		"Vertical padding"                                  : "Preenchimento vertical",
		"Border thickness:"                                 : "Espessura da borda:",
		"Leave empty for no border"                         : "Deixar vazio para ficar sem borda",

		// Insert Link
		"Insert/Modify Link"                                : "Inserir/Modificar link",
		"None (use implicit)"                               : "Nenhum (por omisso)",
		"New window (_blank)"                               : "Nova janela (_blank)",
		"Same frame (_self)"                                : "Mesmo frame (_self)",
		"Top frame (_top)"                                  : "Frame de cima (_top)",
		"Other"                                             : "Outro",
		"Target:"                                           : "Alvo:",
		"Title (tooltip):"                                  : "Ttulo (tooltip):",

		"URL:"                                              : "URL:",
		"You must enter the URL where this link points to"  : "Voc deve digitar o link para o qual aponta",

		// Insert Table
		"Insert Table"                                      : "Inserir Tabela",
		"Rows:"                                             : "Linhas:",
		"Number of rows"                                    : "Nmero de linhas",
		"Cols:"                                             : "Colunas:",
		"Number of columns"                                 : "Nmero de colunas",
		"Width:"                                            : "Largura:",
		"Width of the table"                                : "Largura da tabela",
		"Percent"                                           : "Porcentagem",
		"Pixels"                                            : "Pixel",
		"Em"                                                : "Em",
		"Width unit"                                        : "Unidade de largura",
		"Positioning of this table"                         : "Posicionamento da tabela",
		"Cell spacing:"                                     : "Espaamento da clula:",
		"Space between adjacent cells"                      : "Espao entre clulas adjacentes",
		"Cell padding:"                                     : "Preenchimento da clula:",
		"Space between content and border in cell"          : "Espao entre o contedo e a borda da clula",
		// Insert Image
		"Insert Image"                                      : "Inserir imagem",
		"Image URL:"                                        : "Endereo da imagem:",
		"Enter the image URL here"                          : "Informe o endereo da imagem aqui",
		"Preview"                                           : "Previso",
		"Preview the image in a new window"                 : "Previso da imagem numa nova janela",
		"Alternate text:"                                   : "Texto alternativo:",
		"For browsers that don't support images"            : "Para navegadores que no suportam imagens",
		"Positioning of this image"                         : "Posicionamento desta imagem",
		"Image Preview:"                                    : "Previso da imagem:"
	}
};
