// I18N constants

// LANG: "pt_pt", ENCODING: UTF-8 | ISO-8859-1
// Author: João P Matos, jmatos@math.ist.utl.pt

// FOR TRANSLATORS:
//
//   1. PLEASE PUT YOUR CONTACT INFO IN THE ABOVE LINE
//      (at least a valid email address)
//
//   2. PLEASE TRY TO USE UTF-8 FOR ENCODING;
//      (if this is not possible, please include a comment
//       that states what encoding is necessary.)


HTMLArea.I18N = {

	// the following should be the filename without .js extension
	// it will be used for automatically load plugin language.
	lang: "pt_pt",

	tooltips: {
		bold:           "Negrito",
		italic:         "Itálico",
		underline:      "Sublinhado",
		strikethrough:  "Riscado",
		subscript:      "Subscrito",
		superscript:    "Superescrito",
		justifyleft:    "Alinhado à esquerda",
		justifycenter:  "Centrado",
		justifyright:   "Alinhado à direita",
		justifyfull:    "Justificado",
		orderedlist:    "Lista ordenada",
		unorderedlist:  "Lista não ordenada",
		outdent:        "Diminuir a indentação",
		indent:         "Aumentar a indentação",
		forecolor:      "Cor do texto",
		hilitecolor:    "Cor de ênfase",
		horizontalrule: "Linha horizontal",
		createlink:     "Inserir uma hiperligação",
		insertimage:    "Inserir/Modificar uma imagem",
		inserttable:    "Inserir uma tabela",
		htmlmode:       "Mostrar código fonte",
		popupeditor:    "Alargar o editor",
		about:          "A propósito do editor",
		showhelp:       "Ajuda do editor",
		textindicator:  "Estilo corrente",
		undo:           "Anular a última acção",
		redo:           "Repetir a última acção",
		cut:            "Cortar",
		copy:           "Copiar",
		paste:          "Colar",
		lefttoright:    "Da esquerda para a direita",
		righttoleft:    "Da direita para a esquerda"
	},

	buttons: {
		"ok":           "OK",
		"cancel":       "Cancelar"
	},

	msg: {
		"Path":         "Caminho",
		"TEXT_MODE":    "Está em MODO TEXTO.  Premir o botão [<>] para regressar ao modo gráfico.",

		"IE-sucks-full-screen" :
		// translate here
		"O modo de écrã completo pode causar problemas ao IE, " +
		"devido a problemas deste que foram impossíveis de evitar.  " +
		"Os sintomas podem ser erros no écrã, a falta de " +
		"funções no editor ou flahas catastróficas aletórias do sistema operativo.  Se o seu  " +
		"sistema é Windows 9x, é possível que sofra um erro de tipo " +
		"'General Protection Fault' e que tenha de recomeçar o seu computador." +
		"\n\nConsidere-se avisado.  Prima OK se deseja mesmo assim " +
		"testar o modo de écrã."
	},

	dialogs: {
		"OK"                                                : "OK",
		"Cancel"                                            : "Cancelar",
		"Alignment:"                                        : "Alinhamento:",
		"Not set"                                           : "Não definido",
		"Left"                                              : "Esquerda",
		"Right"                                             : "Direita",
		"Texttop"                                           : "Topo do texto",
		"Absmiddle"                                         : "Absmiddle",
		"Baseline"                                          : "Linha base",
		"Absbottom"                                         : "Absbottom",
		"Bottom"                                            : "Fundo",
		"Middle"                                            : "Meio",
		"Top"                                               : "Topo",

		"Layout"                                            : "Formatação",
		"Spacing"                                           : "Espaçamento",
		"Horizontal:"                                       : "Horizontal:",
		"Horizontal padding"                                : "Enchimento horizontal",
		"Vertical:"                                         : "Vertical:",
		"Vertical padding"                                  : "Enchimento vertical",
		"Border thickness:"                                 : "Espessura do bordo:",
		"Leave empty for no border"                         : "Deixar vazio para ausência de bordo",

		// Insert Link
		"Insert/Modify Link"                                : "Inserir/Modificar ligação",
		"None (use implicit)"                               : "Nenhum (por omissão)",
		"New window (_blank)"                               : "Nova janela (_blank)",
		"Same frame (_self)"                                : "Mesmo caixilho (_self)",
		"Top frame (_top)"                                  : "Caixilho de topo (_top)",
		"Other"                                             : "Outro",
		"Target:"                                           : "Alvo:",
		"Title (tooltip):"                                  : "Título (tooltip):",

		"URL:"                                              : "Endereço web:",
		"You must enter the URL where this link points to"  : "Deve introduzir o endereço da ligação",

		// Insert Table
		"Insert Table"                                      : "Inserir Tabela",
		"Rows:"                                             : "Linhas:",
		"Number of rows"                                    : "Número de linhas",
		"Cols:"                                             : "Colunas:",
		"Number of columns"                                 : "Número de colunas",
		"Width:"                                            : "Largura:",
		"Width of the table"                                : "Largura da tabela",
		"Percent"                                           : "Percentagem",
		"Pixels"                                            : "Pixéis",
		"Em"                                                : "Em",
		"Width unit"                                        : "Unidade de largura",
		"Positioning of this table"                         : "Posicionamento da tabela",
		"Cell spacing:"                                     : "Espaçamento da célula:",
		"Space between adjacent cells"                      : "Espaço entre células adjacentes",
		"Cell padding:"                                     : "Enchimento da célula:",
		"Space between content and border in cell"          : "Espaço entre conteúdo e bordo da célula",
		// Insert Image
		"Insert Image"                                      : "Inserir imagem",
		"Image URL:"                                        : "Endereço da imagem:",
		"Enter the image URL here"                          : "Introduza o endereço da imagem aqui",
		"Preview"                                           : "Previsão",
		"Preview the image in a new window"                 : "Prever a imagem numa nova janela",
		"Alternate text:"                                   : "Texto alternativo:",
		"For browsers that don't support images"            : "Para navegadores que não suportam imagens",
		"Positioning of this image"                         : "Posicionamento desta imagem",
		"Image Preview:"                                    : "Previsão da imagem:"
	}
};
